handler = (req, res) ->
	reply_err = (req, res, msg) ->
		res.writeHead(200, 'Content-Type': 'text/plain')
		return res.end("Error loading #{req.url} \"#{msg}\"")
	switch req.url
		when '/', '/index.html'
			filename = __dirname + '/index.html'
			type = 'text/html'
		when '/jquery.js'
			filename = '/usr/share/javascript/jquery/jquery.min.js'
			type = 'text/javascript'
		when '/terminal.js'
			filename = __dirname + '/terminal.coffee'
			type = 'text/javascript'
		when '/client.js'
			filename = __dirname + '/client.coffee'
			type = 'text/javascript'
		else
			return reply_err req, res
	fs.readFile filename, 'utf8', (err, data) ->
		return reply_err req, res, err if err

		if filename.substr(filename.length - 7) is '.coffee'
			try
				data = coffee.compile data
			catch e
				return reply_err req, res, "server faild to compile #{filename}: #{JSON.stringify(e)}"

		res.writeHead(200, 'Content-Type': type)
		res.end(data)

coffee = require 'coffee-script'
app = require('http').createServer(handler)
io = require('socket.io').listen(app)
fs = require('fs')
terminal = require('./terminal.coffee')

# SETTINGS
app.listen(2218)
term = terminal.new(104, 66)

sockets = []

io.sockets.on 'connection', (socket) ->
	sockets.push socket
	socket.on 'disconnect', ->
		for i in [i...sockets.length]
			if sockets[i] is socket
				sockets.splice i, 1
				return


	enc_color = (prefix, c) ->
		if c < 8
			return "#{prefix}#{c}"
		if c < 16
			return "#{prefix + 6}#{c - 8}"
		return "#{prefix}8;5;#{c}"

	attr_diff = (a, b) ->
		xo = a ^ b
		parts = []
		if (xo & 0xff)
			parts.push enc_color 3, (b & 0xff)
		if (xo & 0xff00)
			parts.push enc_color 4, ((b & 0xff00) >> 8)
		for [bit, code] in [[0x010000, '1'], [0x200000, '3'], [0x020000, '4'], [0x040000, '5'], [0x080000, '7'], [0x100000, '8']]
			if (xo & bit)
				if (b & bit)
					parts.push code
				else
					parts.push '2' + code
		if parts.length
			return "\x1b[#{parts.join ';'}m"
		else
			return ''

	a = 0x07
	state = ''
	# FIXME handle alt screen
	for y in [0...term.height]
		for x in [0...term.width]
			if term.attributes[y][x] isnt a
				state += attr_diff a, term.attributes[y][x]
				a = term.attributes[y][x]
			state += term.text[y][x]
		if y < term.height - 1
			state += '\n'
	state += attr_diff a, term.a
	state += "\x1b[#{term.y + 1};#{term.x + 1}H"
	unless term.cursor_visible
		state += "\x1b[?25l"
	unless term.scroll_top is 0 and term.scroll_bottom is term.height - 1
		state += "\x1b[#{term.scroll_top};#{term.scroll_bottom}r"
	socket.emit 'init', width: term.width, height: term.height, text: state

process.stdin.resume()
process.stdin.setEncoding 'utf8'

process.stdin.on 'data', (data) ->
	term.update data
	for s in sockets
		s.emit 'data', data

process.stdin.on 'end', -> process.exit()
